import greenfoot.*;

/**
 * Stalagmiet
 */
public class Onderstekel extends Actor {
    private Punten punten; // maken we null zodra de punten gegeven zijn

    public Onderstekel(int nr, Punten punten) {
        setImage("stekel" + nr + "onder.png");
        this.punten = punten;
    }

    /**
     * De verticale positie van het middelpunt van deze stekel
     */
    public int getMiddelpuntY () {
        return 400 - 24 - getImage().getHeight()/2;
    }        

    /**
     * Verplaats de stekel naar links en verwijder hem als hij de linkerrand bereikt heeft.
     * Verhoog de punten wanneer de stekel de linkerhelft van het scherm is gepasseerd.
     */
    public void act() {
        if (getX() <= 0) {
            getWorld().removeObject(this);
        } else {
            setLocation (getX() - 3, getY());
            if (punten != null && getX() < 240) { // iets meer links dan het midden
                punten.verhoog();
                punten = null;
            }       
        }
    }    
}
