import greenfoot.*; 

/**
 * De vleermuis
 */
public class Vleermuis extends Actor {

    private int snelheid; // huidige valssnelheid

    private boolean dood; // is de vleermuis dood?

    public Vleermuis () {
        dood = false;
    }

    private void stijg() {
        setLocation (getX(), getY() - 15);
        setImage ("vleermuis2.png");
        snelheid = 0;        
    }

    private void val() {
        snelheid += 5;
        setLocation (getX(), getY() + snelheid);
        setImage ("vleermuis1.png");
    }

    /**
     * Kijk of de grond, het plafond of een stekel worden geraakt
     */
    private boolean isGeraakt() {
        int halveHoogte = getImage().getHeight()/2;
        return
        // plafond
        getY() < 24 + halveHoogte ||
            // grond
        getY() > 400 -24 - halveHoogte ||
            // stekels
        isTouching(Onderstekel.class) || isTouching(Bovenstekel.class);
    }    

    /**
     * Sterf nadat een stekel is geraakt
     */
    private void sterf() {
        dood = true;
        snelheid = 0;
        setImage ("vleermuis2.png");
        turn (180);
    }

    /**
     * Beweeg op en neer. Controleer of de vleermuis is geraakt - en sterf dan. 
     */
    public void act() 
    {
        if (dood) {
            val();
            if (getY() + getImage().getHeight()/2 > 400) {
                Greenfoot.stop();
            }           
        } else if (isGeraakt()) {
            sterf();
        } else if ("space".equals(Greenfoot.getKey())) {
            stijg();
        } else {
            val();
        }

    }    
}
